<template>
	<td>
		<select-box
			tabindex="-1"
			:remote="searchTasks"
			:model-value="item.taskId"
			@update:model-value="(val) => update('taskId', val)"
			:init-data="[initTask]"
		/>
	</td>
	<td>
		<DateControl
			tabindex="-1"
			:model-value="item.date"
			@update:model-value="(val) => update('date', val)"
		/>
	</td>
	<td>
		<TimeControl
			:model-value="item.start"
			@update:model-value="(val) => update('start', val)"
			:max="MAX_TIME"
			format="time"
			:resetable="false"
		/>
	</td>
	<td>
		<TimeControl
			:model-value="item.end"
			@update:model-value="(val) => update('end', val)"
			:max="MAX_TIME"
			format="time"
			:resetable="false"
		/>
	</td>
	<td>
		<TimeControl
			:model-value="item.duration"
			@update:model-value="(val) => update('duration', val)"
			:resetable="false"
		/>
	</td>
	<td>
		<el-icon class="btn-delete" @click="() => emits('delete', item)">
			<delete />
		</el-icon>
	</td>
</template>

<script lang="ts" setup>import { computed, PropType, ref } from 'vue';
import { addDuration, durationCompare, DurationTime, pipe, subDuration, T } from '../../lib/utils';
import { TimesheetDetailItem } from '../ts/types';
import DateControl from './controls/DateControl.vue';
import TimeControl from './controls/TimeControl.vue';
import { ElIcon } from "element-plus";
import { Delete } from "@element-plus/icons";
import SelectBox from './controls/SelectBox.vue';
import { clickupClient } from '../ts/apis';
import { Task, TE } from '../../lib/types';

const MAX_TIME = DurationTime.create(23, 59, 59);

const props = defineProps<{
	modelValue: TimesheetDetailItem,
	teamId: number,
}>();

const initTask = computed<Item>(() => ({
	key: props.modelValue.taskId || '',
	value: props.modelValue.name || ''
}));

const item = computed(() => props.modelValue);

const emits = defineEmits<{
	(e: "update:modelValue", item: TimesheetDetailItem): void
	(e: "delete", item: TimesheetDetailItem): void
}>();

function update<T extends keyof TimesheetDetailItem>(prop: T, value: TimesheetDetailItem[T]) {
	const newItem = {
		...item.value,
		[prop]: value,
	};

	switch (prop) {
		case "duration":
			newItem.end = calcEnd(newItem.start, newItem.duration);
			break;
		case "start":
		case "end":
			newItem.duration = calcDuration(newItem.start, newItem.end);
			break;

		case "taskId":
			newItem.taskId = newItem.taskId || '';
			break;
	}

	emits("update:modelValue", newItem);
}

interface Item {
	key: string;
	value: string;
}

function searchTasks(query: string): Task<Item[]> {
	return pipe(
		clickupClient.searchTasks({
			teamId: props.teamId,
			query
		}),
		TE.map(items => items.map<Item>(itm => ({
			key: itm.id,
			value: itm.name
		}))),
		TE.fold(
			e => T.of([]),
			items => T.of(items),
		)
	);
}

function calcEnd(start: DurationTime, duration: DurationTime) {
	let end = addDuration(start, duration);
	if (durationCompare(end, MAX_TIME) >= 0) {
		return subDuration(end, MAX_TIME);
	}
	return end;
}

function calcDuration(start: DurationTime, end: DurationTime) {
	if (durationCompare(start, end) > 0) {
		end = addDuration(end, MAX_TIME);
	}

	return subDuration(end, start);
}

</script>

<style lang="scss" scoped>
.btn-delete {
	&:hover {
		color: red;
	}
}
</style>